<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="description" content="PHP Demo piece: Average">
<meta name="keywords" content="PHP,validation,email,date, timestamp,HTML,CSS,jQuery">
<meta name="author" content="Tom Blum">
<link rel="stylesheet" type="text/css" href="css/GreenWindow.css" />
<title>PHP Week 3</title>
<script src="http://code.jquery.com/jquery-latest.min.js"
        type="text/javascript"></script>
<script>
	 $(document).ready(function () {
     	
		//when submit button is clicked, make sure that three numbers were entered
		$("#btnSubmit").click(function() {
			var ok = true;
			$("input.score").each(function(){					
					if(!$.isNumeric($(this).val()))
					{
						alert("Your scores must all be numbers.");
						$(this).focus();
						ok=false;
						return ok;	
					}
					else
					{
						if($(this).val() < 0 || $(this).val() > 100)
						{
							alert("Your scores must be between 0 and 100.");
							$(this).focus();
							ok=false;
							return ok;
						}
					}
				});  //end each
			return ok;
		});  //end submit click		
	 });  //end ready
</script>       
</head>

<body>
<?php
 error_reporting(E_ALL);
 ini_set("display_errors", 1);
?>
<div class="greenWindow">
<h1>PHP Week 3</h1>
</div>
<div class="greenWindow">
<h2>Hello, today is <?php echo date('l'); echo " the "; echo date('j'); echo "<sup>"; echo date('S'); 
echo "</sup> of "; echo date('F Y'); ?></h2>
<p>Enter your name and test scores.</p>
</div>
<div class="greenWindow">
<form action='PHP_Week_3.php' method="post">
<label for="txtFirstName">
First Name:
<input type='text' id='txtFirstName' name='txtFirstName' class="user" />
</label><br /> 
<label for="txtLastName">
Last Name:
<input type='text' id='txtLastName' name='txtLastName' class="user" />
</label><br /> <br />
<label for="txtTest1">
Test 1:
<input type='text' id='txtTest1' name='txtTest1' class="score" />
</label><br />
<label for="txtTest2">
Test 2:
<input type='text' id='txtTest2' name='txtTest2' class="score"/>
</label><br />
<label for="txtTest1">
Test 3:
<input type='text' id='txtTest3' name='txtTest3' class="score" />
</label><br /><br /> 
<label for="chkEmail">
<input type='checkbox' id='chkEmail' name='chkEmail' class="email" /> 
Check here if you would like the results emailed to you. 
</label><br /> 
<label for="txtEmail">
Email:
<input type='text' id='txtEmail' name='txtEmail' />
</label><br /> <br />
<input type='submit' id='btnSubmit' name='btnSubmit' value='Submit scores'  /> 
</form>
</div>
<?php 

	// http://stackoverflow.com/questions/6569974/page-ispostback-equivalent-in-php
	if($_SERVER['REQUEST_METHOD'] == 'POST')
	{
		//echo "clicked";		
		$problem=false;
		
		echo "<div class=\"greenWindow\">";
			
		$fName = $_POST['txtFirstName'];
		$fName =  htmlspecialchars($fName, ENT_QUOTES,'UTF-8' );
		$fName = trim($fName);
		if(strlen($fName)==0)
		{	
			echo "You did not enter a first name.";
			$problem=true;
		}
	
		$lName = $_POST['txtLastName'];
		$lName =  htmlspecialchars($lName, ENT_QUOTES,'UTF-8' );
		$lName = trim($lName);
		if(strlen($lName)==0)
		{	
			echo "You did not enter a last name.";
			$problem=true;
		}
		
		if(!$problem)
		{
			echo "<h2>Welcome $fName $lName!</h2>";
		}
			
			
		$scores=array(0,0,0);
		$sum = 0;
		
		//loop over array -- retrieve values from form
		for($i=0; $i<count($scores); $i++)
  		{
			//take score from form assign to array element
			$scores[$i] = $_POST['txtTest' . ($i+1)];
			$scores[$i] =  htmlspecialchars($scores[$i], ENT_QUOTES,'UTF-8' );
  			
			//display array element value on page
			echo $scores[$i];
			if($i < count($scores) -2)
			{
				echo ", ";
			}
			else if($i == count($scores) -2)
			{
				echo ", and ";
			}
			else
			{
				echo ".<br /><br />";	
			}
		}
		
		//loop over array -- validate entries
		for($i=0; $i<count($scores); $i++)
  		{	
			// http://php.net/manual/en/function.is-numeric.php
			if(is_numeric($scores[$i]))
			{
				if(0 <= $scores[$i] && $scores[$i] <= 100)
				{
					//echo "Test score valid."; 
				}
				else
				{
					echo "There is a problem with the test score ($scores[$i]) you entered.";
					echo "It should fall between 0 and 100. <br />";
					$problem = true;
				}
			}
			else
			{
					echo "There is a problem with the test score ($scores[$i]) you entered.";
					echo "It should be a number and between 0 and 100. <br />";
					$problem = true;
			}
		}
		
		if(!$problem)
		{
			for($i=0; $i<count($scores); $i++)
  			{
				//sum scores -- toward taking average
				$sum += $scores[$i];
  			}
			//divide sum of scores by number of scores and display average
			$sum /= count($scores);
			echo "<br /><br /> And the average is $sum.<br /><br />";
		}
			
			// http://www.homeandlearn.co.uk/php/php4p11.html
			if(isset($_POST['chkEmail']))
			{
				// http://php.net/manual/en/filter.examples.validation.php
				$email = $_POST['txtEmail'];
				$email = trim($email);
				if (filter_var($email, FILTER_VALIDATE_EMAIL)) 
				{
    				//echo "$email is considered a valid email address.";
					//echo "send email";	
					$return_address ="blum@lasalle.edu";
					$subject = "Average score";
					$message = "<html>";
					$message .= "<h1>The average of your scores is $sum.</h1>";
					$message .= "</html>";
					$headers = "from: $return_address\n";
					$headers .= "Content-type: text/html;charset=iso-8859-1";
					$result = mail($email, $subject, $message, $headers);
					if(!$result)
					{
						echo "Problems sending email.<br />";	
					}
					else
					{
						echo "An email has been sent to $email.<br />";
					}
				}
				else
				{
    				echo "$email is NOT considered a valid email address.";
				}
			} //end if user checked email checkbox		
			echo "</div>";
		}
?>

<div class="greenWindow">
<h2><a target="_blank" href="http://www.visitphilly.com/events/philadelphia/first-friday/">First Fridays</a></h2>
<p>"Hosted by the Old City Arts Association since its 1991 inception, First Friday is a unique cultural event in Philadelphia and one of the city's most popular evening escapes. Held the first Friday night of each month, this arts community "open house" brings together city dwellers and suburbanites, contemporary arts and antique collectors, aficionados of classical and contemporary design, and theater and performance buffs."</p>
(<a target="_blank" href="http://www.yelp.com/events/philadelphia-first-friday">http://www.yelp.com/events/philadelphia-first-friday</a>)
<h3>The next twelve First Fridays are on:</h3>
<?php 
	$d = getdate();
	$m = $d["mon"];
	$y = $d["year"];

	$d = getdate(mktime(1,1,1,$m,1,$y));  //the first of the month  
	$ff = (5 - $d["wday"] +7)%7+1;  //the first friday
	
	//see if today is before or after this month's First Friday
	if(mktime(1,1,1,$m,$ff,$y)>mktime(1,1,1))
	{
		$d = getdate(mktime(1,1,1,$m,$ff,$y));
	}
	else
	{
		$m++; //go to next month
		$d = getdate(mktime(1,1,1,$m,1,$y));  
		$ff = (5 - $d["wday"] +7)%7+1;
		$d = getdate(mktime(1,1,1,$m,$ff,$y));
	}
	echo $d["month"] . " " . $d["mday"] . ", " . $d["year"] .  "<br />";

for($i=1; $i<12; $i++)
{
	$d = getdate(mktime(1,1,1,$m+$i,1,$y));  
	$ff = (5 - $d["wday"] +7)%7+1;
	$d = getdate(mktime(1,1,1,$m+$i,$ff,$y));
	if($m+$i >12)
	{
		$m -=12;
		$y++;	
	}
	echo $d["month"] . " " . $d["mday"] . ", " . $d["year"] .  "<br />";
}
?>
</div>

</body>
</html>